t / test-lib.shon commit test-lib.sh: unset XDG_CACHE_HOME (7976e90)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39################################################################
  40# It appears that people try to run tests without building...
  41"$GIT_BUILD_DIR/git" >/dev/null
  42if test $? != 1
  43then
  44        echo >&2 'error: you do not seem to have built git yet.'
  45        exit 1
  46fi
  47
  48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  49export PERL_PATH SHELL_PATH
  50
  51# if --tee was passed, write the output not only to the terminal, but
  52# additionally to the file test-results/$BASENAME.out, too.
  53case "$GIT_TEST_TEE_STARTED, $* " in
  54done,*)
  55        # do not redirect again
  56        ;;
  57*' --tee '*|*' --va'*|*' --verbose-log '*)
  58        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  59        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  60
  61        # Make this filename available to the sub-process in case it is using
  62        # --verbose-log.
  63        GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
  64        export GIT_TEST_TEE_OUTPUT_FILE
  65
  66        # Truncate before calling "tee -a" to get rid of the results
  67        # from any previous runs.
  68        >"$GIT_TEST_TEE_OUTPUT_FILE"
  69
  70        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  71         echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
  72        test "$(cat "$BASE.exit")" = 0
  73        exit
  74        ;;
  75esac
  76
  77# For repeatability, reset the environment to known value.
  78# TERM is sanitized below, after saving color control sequences.
  79LANG=C
  80LC_ALL=C
  81PAGER=cat
  82TZ=UTC
  83export LANG LC_ALL PAGER TZ
  84EDITOR=:
  85# A call to "unset" with no arguments causes at least Solaris 10
  86# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  87# deriving from the command substitution clustered with the other
  88# ones.
  89unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  90        my @env = keys %ENV;
  91        my $ok = join("|", qw(
  92                TRACE
  93                DEBUG
  94                USE_LOOKUP
  95                TEST
  96                .*_TEST
  97                PROVE
  98                VALGRIND
  99                UNZIP
 100                PERF_
 101                CURL_VERBOSE
 102                TRACE_CURL
 103        ));
 104        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 105        print join("\n", @vars);
 106')
 107unset XDG_CACHE_HOME
 108unset XDG_CONFIG_HOME
 109unset GITPERLLIB
 110GIT_AUTHOR_EMAIL=author@example.com
 111GIT_AUTHOR_NAME='A U Thor'
 112GIT_COMMITTER_EMAIL=committer@example.com
 113GIT_COMMITTER_NAME='C O Mitter'
 114GIT_MERGE_VERBOSITY=5
 115GIT_MERGE_AUTOEDIT=no
 116export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 117export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 118export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 119export EDITOR
 120
 121# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 122GIT_TRACE_BARE=1
 123export GIT_TRACE_BARE
 124
 125if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 126then
 127        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 128        export GIT_INDEX_VERSION
 129fi
 130
 131# Add libc MALLOC and MALLOC_PERTURB test
 132# only if we are not executing the test with valgrind
 133if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 134   test -n "$TEST_NO_MALLOC_CHECK"
 135then
 136        setup_malloc_check () {
 137                : nothing
 138        }
 139        teardown_malloc_check () {
 140                : nothing
 141        }
 142else
 143        setup_malloc_check () {
 144                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 145                export MALLOC_CHECK_ MALLOC_PERTURB_
 146        }
 147        teardown_malloc_check () {
 148                unset MALLOC_CHECK_ MALLOC_PERTURB_
 149        }
 150fi
 151
 152: ${ASAN_OPTIONS=detect_leaks=0}
 153export ASAN_OPTIONS
 154
 155# Protect ourselves from common misconfiguration to export
 156# CDPATH into the environment
 157unset CDPATH
 158
 159unset GREP_OPTIONS
 160unset UNZIP
 161
 162case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1631|2|true)
 164        GIT_TRACE=4
 165        ;;
 166esac
 167
 168# Convenience
 169#
 170# A regexp to match 5 and 40 hexdigits
 171_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 172_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 173
 174# Zero SHA-1
 175_z40=0000000000000000000000000000000000000000
 176
 177EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 178EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 179
 180# Line feed
 181LF='
 182'
 183
 184# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 185# when case-folding filenames
 186u200c=$(printf '\342\200\214')
 187
 188export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
 189
 190# Each test should start with something like this, after copyright notices:
 191#
 192# test_description='Description of this test...
 193# This test checks if command xyzzy does the right thing...
 194# '
 195# . ./test-lib.sh
 196test "x$TERM" != "xdumb" && (
 197                test -t 1 &&
 198                tput bold >/dev/null 2>&1 &&
 199                tput setaf 1 >/dev/null 2>&1 &&
 200                tput sgr0 >/dev/null 2>&1
 201        ) &&
 202        color=t
 203
 204while test "$#" -ne 0
 205do
 206        case "$1" in
 207        -d|--d|--de|--deb|--debu|--debug)
 208                debug=t; shift ;;
 209        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 210                immediate=t; shift ;;
 211        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 212                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 213        -r)
 214                shift; test "$#" -ne 0 || {
 215                        echo 'error: -r requires an argument' >&2;
 216                        exit 1;
 217                }
 218                run_list=$1; shift ;;
 219        --run=*)
 220                run_list=${1#--*=}; shift ;;
 221        -h|--h|--he|--hel|--help)
 222                help=t; shift ;;
 223        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 224                verbose=t; shift ;;
 225        --verbose-only=*)
 226                verbose_only=${1#--*=}
 227                shift ;;
 228        -q|--q|--qu|--qui|--quie|--quiet)
 229                # Ignore --quiet under a TAP::Harness. Saying how many tests
 230                # passed without the ok/not ok details is always an error.
 231                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 232        --with-dashes)
 233                with_dashes=t; shift ;;
 234        --no-color)
 235                color=; shift ;;
 236        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 237                valgrind=memcheck
 238                shift ;;
 239        --valgrind=*)
 240                valgrind=${1#--*=}
 241                shift ;;
 242        --valgrind-only=*)
 243                valgrind_only=${1#--*=}
 244                shift ;;
 245        --tee)
 246                shift ;; # was handled already
 247        --root=*)
 248                root=${1#--*=}
 249                shift ;;
 250        --chain-lint)
 251                GIT_TEST_CHAIN_LINT=1
 252                shift ;;
 253        --no-chain-lint)
 254                GIT_TEST_CHAIN_LINT=0
 255                shift ;;
 256        -x)
 257                trace=t
 258                verbose=t
 259                shift ;;
 260        --verbose-log)
 261                verbose_log=t
 262                shift ;;
 263        *)
 264                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 265        esac
 266done
 267
 268if test -n "$valgrind_only"
 269then
 270        test -z "$valgrind" && valgrind=memcheck
 271        test -z "$verbose" && verbose_only="$valgrind_only"
 272elif test -n "$valgrind"
 273then
 274        verbose=t
 275fi
 276
 277if test -n "$color"
 278then
 279        # Save the color control sequences now rather than run tput
 280        # each time say_color() is called.  This is done for two
 281        # reasons:
 282        #   * TERM will be changed to dumb
 283        #   * HOME will be changed to a temporary directory and tput
 284        #     might need to read ~/.terminfo from the original HOME
 285        #     directory to get the control sequences
 286        # Note:  This approach assumes the control sequences don't end
 287        # in a newline for any terminal of interest (command
 288        # substitutions strip trailing newlines).  Given that most
 289        # (all?) terminals in common use are related to ECMA-48, this
 290        # shouldn't be a problem.
 291        say_color_error=$(tput bold; tput setaf 1) # bold red
 292        say_color_skip=$(tput setaf 4) # blue
 293        say_color_warn=$(tput setaf 3) # brown/yellow
 294        say_color_pass=$(tput setaf 2) # green
 295        say_color_info=$(tput setaf 6) # cyan
 296        say_color_reset=$(tput sgr0)
 297        say_color_="" # no formatting for normal text
 298        say_color () {
 299                test -z "$1" && test -n "$quiet" && return
 300                eval "say_color_color=\$say_color_$1"
 301                shift
 302                printf "%s\\n" "$say_color_color$*$say_color_reset"
 303        }
 304else
 305        say_color() {
 306                test -z "$1" && test -n "$quiet" && return
 307                shift
 308                printf "%s\n" "$*"
 309        }
 310fi
 311
 312TERM=dumb
 313export TERM
 314
 315error () {
 316        say_color error "error: $*"
 317        GIT_EXIT_OK=t
 318        exit 1
 319}
 320
 321say () {
 322        say_color info "$*"
 323}
 324
 325if test -n "$HARNESS_ACTIVE"
 326then
 327        if test "$verbose" = t || test -n "$verbose_only"
 328        then
 329                printf 'Bail out! %s\n' \
 330                 'verbose mode forbidden under TAP harness; try --verbose-log'
 331                exit 1
 332        fi
 333fi
 334
 335test "${test_description}" != "" ||
 336error "Test script did not set test_description."
 337
 338if test "$help" = "t"
 339then
 340        printf '%s\n' "$test_description"
 341        exit 0
 342fi
 343
 344exec 5>&1
 345exec 6<&0
 346exec 7>&2
 347if test "$verbose_log" = "t"
 348then
 349        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 350elif test "$verbose" = "t"
 351then
 352        exec 4>&2 3>&1
 353else
 354        exec 4>/dev/null 3>/dev/null
 355fi
 356
 357# Send any "-x" output directly to stderr to avoid polluting tests
 358# which capture stderr. We can do this unconditionally since it
 359# has no effect if tracing isn't turned on.
 360#
 361# Note that this sets up the trace fd as soon as we assign the variable, so it
 362# must come after the creation of descriptor 4 above. Likewise, we must never
 363# unset this, as it has the side effect of closing descriptor 4, which we
 364# use to show verbose tests to the user.
 365#
 366# Note also that we don't need or want to export it. The tracing is local to
 367# this shell, and we would not want to influence any shells we exec.
 368BASH_XTRACEFD=4
 369
 370test_failure=0
 371test_count=0
 372test_fixed=0
 373test_broken=0
 374test_success=0
 375
 376test_external_has_tap=0
 377
 378die () {
 379        code=$?
 380        if test -n "$GIT_EXIT_OK"
 381        then
 382                exit $code
 383        else
 384                echo >&5 "FATAL: Unexpected exit with code $code"
 385                exit 1
 386        fi
 387}
 388
 389GIT_EXIT_OK=
 390trap 'die' EXIT
 391trap 'exit $?' INT
 392
 393# The user-facing functions are loaded from a separate file so that
 394# test_perf subshells can have them too
 395. "$TEST_DIRECTORY/test-lib-functions.sh"
 396
 397# You are not expected to call test_ok_ and test_failure_ directly, use
 398# the test_expect_* functions instead.
 399
 400test_ok_ () {
 401        test_success=$(($test_success + 1))
 402        say_color "" "ok $test_count - $@"
 403}
 404
 405test_failure_ () {
 406        test_failure=$(($test_failure + 1))
 407        say_color error "not ok $test_count - $1"
 408        shift
 409        printf '%s\n' "$*" | sed -e 's/^/#      /'
 410        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 411}
 412
 413test_known_broken_ok_ () {
 414        test_fixed=$(($test_fixed+1))
 415        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 416}
 417
 418test_known_broken_failure_ () {
 419        test_broken=$(($test_broken+1))
 420        say_color warn "not ok $test_count - $@ # TODO known breakage"
 421}
 422
 423test_debug () {
 424        test "$debug" = "" || eval "$1"
 425}
 426
 427match_pattern_list () {
 428        arg="$1"
 429        shift
 430        test -z "$*" && return 1
 431        for pattern_
 432        do
 433                case "$arg" in
 434                $pattern_)
 435                        return 0
 436                esac
 437        done
 438        return 1
 439}
 440
 441match_test_selector_list () {
 442        title="$1"
 443        shift
 444        arg="$1"
 445        shift
 446        test -z "$1" && return 0
 447
 448        # Both commas and whitespace are accepted as separators.
 449        OLDIFS=$IFS
 450        IFS='   ,'
 451        set -- $1
 452        IFS=$OLDIFS
 453
 454        # If the first selector is negative we include by default.
 455        include=
 456        case "$1" in
 457                !*) include=t ;;
 458        esac
 459
 460        for selector
 461        do
 462                orig_selector=$selector
 463
 464                positive=t
 465                case "$selector" in
 466                        !*)
 467                                positive=
 468                                selector=${selector##?}
 469                                ;;
 470                esac
 471
 472                test -z "$selector" && continue
 473
 474                case "$selector" in
 475                        *-*)
 476                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 477                                then
 478                                        echo "error: $title: invalid non-numeric in range" \
 479                                                "start: '$orig_selector'" >&2
 480                                        exit 1
 481                                fi
 482                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 483                                then
 484                                        echo "error: $title: invalid non-numeric in range" \
 485                                                "end: '$orig_selector'" >&2
 486                                        exit 1
 487                                fi
 488                                ;;
 489                        *)
 490                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 491                                then
 492                                        echo "error: $title: invalid non-numeric in test" \
 493                                                "selector: '$orig_selector'" >&2
 494                                        exit 1
 495                                fi
 496                esac
 497
 498                # Short cut for "obvious" cases
 499                test -z "$include" && test -z "$positive" && continue
 500                test -n "$include" && test -n "$positive" && continue
 501
 502                case "$selector" in
 503                        -*)
 504                                if test $arg -le ${selector#-}
 505                                then
 506                                        include=$positive
 507                                fi
 508                                ;;
 509                        *-)
 510                                if test $arg -ge ${selector%-}
 511                                then
 512                                        include=$positive
 513                                fi
 514                                ;;
 515                        *-*)
 516                                if test ${selector%%-*} -le $arg \
 517                                        && test $arg -le ${selector#*-}
 518                                then
 519                                        include=$positive
 520                                fi
 521                                ;;
 522                        *)
 523                                if test $arg -eq $selector
 524                                then
 525                                        include=$positive
 526                                fi
 527                                ;;
 528                esac
 529        done
 530
 531        test -n "$include"
 532}
 533
 534maybe_teardown_verbose () {
 535        test -z "$verbose_only" && return
 536        exec 4>/dev/null 3>/dev/null
 537        verbose=
 538}
 539
 540last_verbose=t
 541maybe_setup_verbose () {
 542        test -z "$verbose_only" && return
 543        if match_pattern_list $test_count $verbose_only
 544        then
 545                exec 4>&2 3>&1
 546                # Emit a delimiting blank line when going from
 547                # non-verbose to verbose.  Within verbose mode the
 548                # delimiter is printed by test_expect_*.  The choice
 549                # of the initial $last_verbose is such that before
 550                # test 1, we do not print it.
 551                test -z "$last_verbose" && echo >&3 ""
 552                verbose=t
 553        else
 554                exec 4>/dev/null 3>/dev/null
 555                verbose=
 556        fi
 557        last_verbose=$verbose
 558}
 559
 560maybe_teardown_valgrind () {
 561        test -z "$GIT_VALGRIND" && return
 562        GIT_VALGRIND_ENABLED=
 563}
 564
 565maybe_setup_valgrind () {
 566        test -z "$GIT_VALGRIND" && return
 567        if test -z "$valgrind_only"
 568        then
 569                GIT_VALGRIND_ENABLED=t
 570                return
 571        fi
 572        GIT_VALGRIND_ENABLED=
 573        if match_pattern_list $test_count $valgrind_only
 574        then
 575                GIT_VALGRIND_ENABLED=t
 576        fi
 577}
 578
 579want_trace () {
 580        test "$trace" = t && test "$verbose" = t
 581}
 582
 583# This is a separate function because some tests use
 584# "return" to end a test_expect_success block early
 585# (and we want to make sure we run any cleanup like
 586# "set +x").
 587test_eval_inner_ () {
 588        # Do not add anything extra (including LF) after '$*'
 589        eval "
 590                want_trace && set -x
 591                $*"
 592}
 593
 594test_eval_ () {
 595        # We run this block with stderr redirected to avoid extra cruft
 596        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 597        # the shell from printing the "set +x" to turn it off (nor the saving
 598        # of $? before that). But we can make sure that the output goes to
 599        # /dev/null.
 600        #
 601        # The test itself is run with stderr put back to &4 (so either to
 602        # /dev/null, or to the original stderr if --verbose was used).
 603        {
 604                test_eval_inner_ "$@" </dev/null >&3 2>&4
 605                test_eval_ret_=$?
 606                if want_trace
 607                then
 608                        set +x
 609                        if test "$test_eval_ret_" != 0
 610                        then
 611                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 612                        fi
 613                fi
 614        } 2>/dev/null
 615        return $test_eval_ret_
 616}
 617
 618test_run_ () {
 619        test_cleanup=:
 620        expecting_failure=$2
 621
 622        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 623                # turn off tracing for this test-eval, as it simply creates
 624                # confusing noise in the "-x" output
 625                trace_tmp=$trace
 626                trace=
 627                # 117 is magic because it is unlikely to match the exit
 628                # code of other programs
 629                test_eval_ "(exit 117) && $1"
 630                if test "$?" != 117; then
 631                        error "bug in the test script: broken &&-chain: $1"
 632                fi
 633                trace=$trace_tmp
 634        fi
 635
 636        setup_malloc_check
 637        test_eval_ "$1"
 638        eval_ret=$?
 639        teardown_malloc_check
 640
 641        if test -z "$immediate" || test $eval_ret = 0 ||
 642           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 643        then
 644                setup_malloc_check
 645                test_eval_ "$test_cleanup"
 646                teardown_malloc_check
 647        fi
 648        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 649        then
 650                echo ""
 651        fi
 652        return "$eval_ret"
 653}
 654
 655test_start_ () {
 656        test_count=$(($test_count+1))
 657        maybe_setup_verbose
 658        maybe_setup_valgrind
 659}
 660
 661test_finish_ () {
 662        echo >&3 ""
 663        maybe_teardown_valgrind
 664        maybe_teardown_verbose
 665}
 666
 667test_skip () {
 668        to_skip=
 669        skipped_reason=
 670        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 671        then
 672                to_skip=t
 673                skipped_reason="GIT_SKIP_TESTS"
 674        fi
 675        if test -z "$to_skip" && test -n "$test_prereq" &&
 676           ! test_have_prereq "$test_prereq"
 677        then
 678                to_skip=t
 679
 680                of_prereq=
 681                if test "$missing_prereq" != "$test_prereq"
 682                then
 683                        of_prereq=" of $test_prereq"
 684                fi
 685                skipped_reason="missing $missing_prereq${of_prereq}"
 686        fi
 687        if test -z "$to_skip" && test -n "$run_list" &&
 688                ! match_test_selector_list '--run' $test_count "$run_list"
 689        then
 690                to_skip=t
 691                skipped_reason="--run"
 692        fi
 693
 694        case "$to_skip" in
 695        t)
 696                say_color skip >&3 "skipping test: $@"
 697                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 698                : true
 699                ;;
 700        *)
 701                false
 702                ;;
 703        esac
 704}
 705
 706# stub; perf-lib overrides it
 707test_at_end_hook_ () {
 708        :
 709}
 710
 711test_done () {
 712        GIT_EXIT_OK=t
 713
 714        if test -z "$HARNESS_ACTIVE"
 715        then
 716                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 717                mkdir -p "$test_results_dir"
 718                base=${0##*/}
 719                test_results_path="$test_results_dir/${base%.sh}.counts"
 720
 721                cat >"$test_results_path" <<-EOF
 722                total $test_count
 723                success $test_success
 724                fixed $test_fixed
 725                broken $test_broken
 726                failed $test_failure
 727
 728                EOF
 729        fi
 730
 731        if test "$test_fixed" != 0
 732        then
 733                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 734        fi
 735        if test "$test_broken" != 0
 736        then
 737                say_color warn "# still have $test_broken known breakage(s)"
 738        fi
 739        if test "$test_broken" != 0 || test "$test_fixed" != 0
 740        then
 741                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 742                msg="remaining $test_remaining test(s)"
 743        else
 744                test_remaining=$test_count
 745                msg="$test_count test(s)"
 746        fi
 747        case "$test_failure" in
 748        0)
 749                # Maybe print SKIP message
 750                if test -n "$skip_all" && test $test_count -gt 0
 751                then
 752                        error "Can't use skip_all after running some tests"
 753                fi
 754                test -z "$skip_all" || skip_all=" # SKIP $skip_all"
 755
 756                if test $test_external_has_tap -eq 0
 757                then
 758                        if test $test_remaining -gt 0
 759                        then
 760                                say_color pass "# passed all $msg"
 761                        fi
 762                        say "1..$test_count$skip_all"
 763                fi
 764
 765                test -d "$remove_trash" &&
 766                cd "$(dirname "$remove_trash")" &&
 767                rm -rf "$(basename "$remove_trash")"
 768
 769                test_at_end_hook_
 770
 771                exit 0 ;;
 772
 773        *)
 774                if test $test_external_has_tap -eq 0
 775                then
 776                        say_color error "# failed $test_failure among $msg"
 777                        say "1..$test_count"
 778                fi
 779
 780                exit 1 ;;
 781
 782        esac
 783}
 784
 785if test -n "$valgrind"
 786then
 787        make_symlink () {
 788                test -h "$2" &&
 789                test "$1" = "$(readlink "$2")" || {
 790                        # be super paranoid
 791                        if mkdir "$2".lock
 792                        then
 793                                rm -f "$2" &&
 794                                ln -s "$1" "$2" &&
 795                                rm -r "$2".lock
 796                        else
 797                                while test -d "$2".lock
 798                                do
 799                                        say "Waiting for lock on $2."
 800                                        sleep 1
 801                                done
 802                        fi
 803                }
 804        }
 805
 806        make_valgrind_symlink () {
 807                # handle only executables, unless they are shell libraries that
 808                # need to be in the exec-path.
 809                test -x "$1" ||
 810                test "# " = "$(head -c 2 <"$1")" ||
 811                return;
 812
 813                base=$(basename "$1")
 814                case "$base" in
 815                test-*)
 816                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
 817                        ;;
 818                *)
 819                        symlink_target="$GIT_BUILD_DIR/$base"
 820                        ;;
 821                esac
 822                # do not override scripts
 823                if test -x "$symlink_target" &&
 824                    test ! -d "$symlink_target" &&
 825                    test "#!" != "$(head -c 2 < "$symlink_target")"
 826                then
 827                        symlink_target=../valgrind.sh
 828                fi
 829                case "$base" in
 830                *.sh|*.perl)
 831                        symlink_target=../unprocessed-script
 832                esac
 833                # create the link, or replace it if it is out of date
 834                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 835        }
 836
 837        # override all git executables in TEST_DIRECTORY/..
 838        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 839        mkdir -p "$GIT_VALGRIND"/bin
 840        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
 841        do
 842                make_valgrind_symlink $file
 843        done
 844        # special-case the mergetools loadables
 845        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 846        OLDIFS=$IFS
 847        IFS=:
 848        for path in $PATH
 849        do
 850                ls "$path"/git-* 2> /dev/null |
 851                while read file
 852                do
 853                        make_valgrind_symlink "$file"
 854                done
 855        done
 856        IFS=$OLDIFS
 857        PATH=$GIT_VALGRIND/bin:$PATH
 858        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 859        export GIT_VALGRIND
 860        GIT_VALGRIND_MODE="$valgrind"
 861        export GIT_VALGRIND_MODE
 862        GIT_VALGRIND_ENABLED=t
 863        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 864        export GIT_VALGRIND_ENABLED
 865elif test -n "$GIT_TEST_INSTALLED"
 866then
 867        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 868        error "Cannot run git from $GIT_TEST_INSTALLED."
 869        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 870        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 871else # normal case, use ../bin-wrappers only unless $with_dashes:
 872        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 873        if ! test -x "$git_bin_dir/git"
 874        then
 875                if test -z "$with_dashes"
 876                then
 877                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 878                fi
 879                with_dashes=t
 880        fi
 881        PATH="$git_bin_dir:$PATH"
 882        GIT_EXEC_PATH=$GIT_BUILD_DIR
 883        if test -n "$with_dashes"
 884        then
 885                PATH="$GIT_BUILD_DIR:$PATH"
 886        fi
 887fi
 888GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 889GIT_CONFIG_NOSYSTEM=1
 890GIT_ATTR_NOSYSTEM=1
 891export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 892
 893if test -z "$GIT_TEST_CMP"
 894then
 895        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 896        then
 897                GIT_TEST_CMP="$DIFF -c"
 898        else
 899                GIT_TEST_CMP="$DIFF -u"
 900        fi
 901fi
 902
 903GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 904export GITPERLLIB
 905test -d "$GIT_BUILD_DIR"/templates/blt || {
 906        error "You haven't built things yet, have you?"
 907}
 908
 909if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
 910then
 911        echo >&2 'You need to build test-chmtime:'
 912        echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
 913        exit 1
 914fi
 915
 916# Test repository
 917TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 918test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 919case "$TRASH_DIRECTORY" in
 920/*) ;; # absolute path is good
 921 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 922esac
 923test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 924rm -fr "$TRASH_DIRECTORY" || {
 925        GIT_EXIT_OK=t
 926        echo >&5 "FATAL: Cannot prepare test area"
 927        exit 1
 928}
 929
 930HOME="$TRASH_DIRECTORY"
 931GNUPGHOME="$HOME/gnupg-home-not-used"
 932export HOME GNUPGHOME
 933
 934if test -z "$TEST_NO_CREATE_REPO"
 935then
 936        test_create_repo "$TRASH_DIRECTORY"
 937else
 938        mkdir -p "$TRASH_DIRECTORY"
 939fi
 940# Use -P to resolve symlinks in our working directory so that the cwd
 941# in subprocesses like git equals our $PWD (for pathname comparisons).
 942cd -P "$TRASH_DIRECTORY" || exit 1
 943
 944this_test=${0##*/}
 945this_test=${this_test%%-*}
 946if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 947then
 948        say_color info >&3 "skipping test $this_test altogether"
 949        skip_all="skip all tests in $this_test"
 950        test_done
 951fi
 952
 953# Provide an implementation of the 'yes' utility
 954yes () {
 955        if test $# = 0
 956        then
 957                y=y
 958        else
 959                y="$*"
 960        fi
 961
 962        i=0
 963        while test $i -lt 99
 964        do
 965                echo "$y"
 966                i=$(($i+1))
 967        done
 968}
 969
 970# Fix some commands on Windows
 971uname_s=$(uname -s)
 972case $uname_s in
 973*MINGW*)
 974        # Windows has its own (incompatible) sort and find
 975        sort () {
 976                /usr/bin/sort "$@"
 977        }
 978        find () {
 979                /usr/bin/find "$@"
 980        }
 981        sum () {
 982                md5sum "$@"
 983        }
 984        # git sees Windows-style pwd
 985        pwd () {
 986                builtin pwd -W
 987        }
 988        # no POSIX permissions
 989        # backslashes in pathspec are converted to '/'
 990        # exec does not inherit the PID
 991        test_set_prereq MINGW
 992        test_set_prereq NATIVE_CRLF
 993        test_set_prereq SED_STRIPS_CR
 994        test_set_prereq GREP_STRIPS_CR
 995        GIT_TEST_CMP=mingw_test_cmp
 996        ;;
 997*CYGWIN*)
 998        test_set_prereq POSIXPERM
 999        test_set_prereq EXECKEEPSPID
1000        test_set_prereq CYGWIN
1001        test_set_prereq SED_STRIPS_CR
1002        test_set_prereq GREP_STRIPS_CR
1003        ;;
1004*)
1005        test_set_prereq POSIXPERM
1006        test_set_prereq BSLASHPSPEC
1007        test_set_prereq EXECKEEPSPID
1008        ;;
1009esac
1010
1011( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1012test -z "$NO_PERL" && test_set_prereq PERL
1013test -z "$NO_PYTHON" && test_set_prereq PYTHON
1014test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1015test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1016
1017# Can we rely on git's output in the C locale?
1018if test -n "$GETTEXT_POISON"
1019then
1020        GIT_GETTEXT_POISON=YesPlease
1021        export GIT_GETTEXT_POISON
1022        test_set_prereq GETTEXT_POISON
1023else
1024        test_set_prereq C_LOCALE_OUTPUT
1025fi
1026
1027# Use this instead of test_cmp to compare files that contain expected and
1028# actual output from git commands that can be translated.  When running
1029# under GETTEXT_POISON this pretends that the command produced expected
1030# results.
1031test_i18ncmp () {
1032        test -n "$GETTEXT_POISON" || test_cmp "$@"
1033}
1034
1035# Use this instead of "grep expected-string actual" to see if the
1036# output from a git command that can be translated either contains an
1037# expected string, or does not contain an unwanted one.  When running
1038# under GETTEXT_POISON this pretends that the command produced expected
1039# results.
1040test_i18ngrep () {
1041        if test -n "$GETTEXT_POISON"
1042        then
1043            : # pretend success
1044        elif test "x!" = "x$1"
1045        then
1046                shift
1047                ! grep "$@"
1048        else
1049                grep "$@"
1050        fi
1051}
1052
1053test_lazy_prereq PIPE '
1054        # test whether the filesystem supports FIFOs
1055        case $(uname -s) in
1056        CYGWIN*|MINGW*)
1057                false
1058                ;;
1059        *)
1060                rm -f testfifo && mkfifo testfifo
1061                ;;
1062        esac
1063'
1064
1065test_lazy_prereq SYMLINKS '
1066        # test whether the filesystem supports symbolic links
1067        ln -s x y && test -h y
1068'
1069
1070test_lazy_prereq FILEMODE '
1071        test "$(git config --bool core.filemode)" = true
1072'
1073
1074test_lazy_prereq CASE_INSENSITIVE_FS '
1075        echo good >CamelCase &&
1076        echo bad >camelcase &&
1077        test "$(cat CamelCase)" != good
1078'
1079
1080test_lazy_prereq UTF8_NFD_TO_NFC '
1081        # check whether FS converts nfd unicode to nfc
1082        auml=$(printf "\303\244")
1083        aumlcdiar=$(printf "\141\314\210")
1084        >"$auml" &&
1085        case "$(echo *)" in
1086        "$aumlcdiar")
1087                true ;;
1088        *)
1089                false ;;
1090        esac
1091'
1092
1093test_lazy_prereq AUTOIDENT '
1094        sane_unset GIT_AUTHOR_NAME &&
1095        sane_unset GIT_AUTHOR_EMAIL &&
1096        git var GIT_AUTHOR_IDENT
1097'
1098
1099test_lazy_prereq EXPENSIVE '
1100        test -n "$GIT_TEST_LONG"
1101'
1102
1103test_lazy_prereq USR_BIN_TIME '
1104        test -x /usr/bin/time
1105'
1106
1107test_lazy_prereq NOT_ROOT '
1108        uid=$(id -u) &&
1109        test "$uid" != 0
1110'
1111
1112test_lazy_prereq JGIT '
1113        type jgit
1114'
1115
1116# SANITY is about "can you correctly predict what the filesystem would
1117# do by only looking at the permission bits of the files and
1118# directories?"  A typical example of !SANITY is running the test
1119# suite as root, where a test may expect "chmod -r file && cat file"
1120# to fail because file is supposed to be unreadable after a successful
1121# chmod.  In an environment (i.e. combination of what filesystem is
1122# being used and who is running the tests) that lacks SANITY, you may
1123# be able to delete or create a file when the containing directory
1124# doesn't have write permissions, or access a file even if the
1125# containing directory doesn't have read or execute permissions.
1126
1127test_lazy_prereq SANITY '
1128        mkdir SANETESTD.1 SANETESTD.2 &&
1129
1130        chmod +w SANETESTD.1 SANETESTD.2 &&
1131        >SANETESTD.1/x 2>SANETESTD.2/x &&
1132        chmod -w SANETESTD.1 &&
1133        chmod -r SANETESTD.1/x &&
1134        chmod -rx SANETESTD.2 ||
1135        error "bug in test sript: cannot prepare SANETESTD"
1136
1137        ! test -r SANETESTD.1/x &&
1138        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1139        status=$?
1140
1141        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1142        rm -rf SANETESTD.1 SANETESTD.2 ||
1143        error "bug in test sript: cannot clean SANETESTD"
1144        return $status
1145'
1146
1147test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1148GIT_UNZIP=${GIT_UNZIP:-unzip}
1149test_lazy_prereq UNZIP '
1150        "$GIT_UNZIP" -v
1151        test $? -ne 127
1152'
1153
1154run_with_limited_cmdline () {
1155        (ulimit -s 128 && "$@")
1156}
1157
1158test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
1159
1160build_option () {
1161        git version --build-options |
1162        sed -ne "s/^$1: //p"
1163}
1164
1165test_lazy_prereq LONG_IS_64BIT '
1166        test 8 -le "$(build_option sizeof-long)"
1167'